"use strict";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _require = require("../index"),
    promisify = _require.promisify;

var cmds = require("../cmds");

var _require2 = require("./test-util"),
    sleep = _require2.sleep;

test("globalVariable() should return a global variable",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee() {
  var _marked, testValue, testGlobalVariable, actual;

  return regeneratorRuntime.wrap(function _callee$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          testGlobalVariable = function _ref3() {
            var _ref2, env;

            return regeneratorRuntime.wrap(function testGlobalVariable$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _context.next = 2;
                    return cmds.globalVariable("process");

                  case 2:
                    _ref2 = _context.sent;
                    env = _ref2.env;
                    return _context.abrupt("return", env.testValue);

                  case 5:
                  case "end":
                    return _context.stop();
                }
              }
            }, _marked, this);
          };

          _marked =
          /*#__PURE__*/
          regeneratorRuntime.mark(testGlobalVariable);
          testValue = Math.random().toString();
          process.env.testValue = testValue;
          _context2.next = 6;
          return promisify(testGlobalVariable)();

        case 6:
          actual = _context2.sent;
          expect(actual).toEqual(testValue);

        case 8:
        case "end":
          return _context2.stop();
      }
    }
  }, _callee, this);
})));
test("call() should call an effects-as-data function",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee2() {
  var _marked2, _marked3, testCallee, testCall, actual, expected;

  return regeneratorRuntime.wrap(function _callee2$(_context5) {
    while (1) {
      switch (_context5.prev = _context5.next) {
        case 0:
          testCall = function _ref6() {
            return regeneratorRuntime.wrap(function testCall$(_context4) {
              while (1) {
                switch (_context4.prev = _context4.next) {
                  case 0:
                    _context4.next = 2;
                    return cmds.call(testCallee, "bar");

                  case 2:
                    return _context4.abrupt("return", _context4.sent);

                  case 3:
                  case "end":
                    return _context4.stop();
                }
              }
            }, _marked3, this);
          };

          testCallee = function _ref5(message) {
            return regeneratorRuntime.wrap(function testCallee$(_context3) {
              while (1) {
                switch (_context3.prev = _context3.next) {
                  case 0:
                    _context3.next = 2;
                    return cmds.echo("foo".concat(message));

                  case 2:
                    return _context3.abrupt("return", _context3.sent);

                  case 3:
                  case "end":
                    return _context3.stop();
                }
              }
            }, _marked2, this);
          };

          _marked2 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCallee), _marked3 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          _context5.next = 5;
          return promisify(testCall)();

        case 5:
          actual = _context5.sent;
          expected = "foobar";
          expect(actual).toEqual(expected);

        case 8:
        case "end":
          return _context5.stop();
      }
    }
  }, _callee2, this);
})));
test("call() should handle errors",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee3() {
  var _marked4, _marked5, testCallee, testCall;

  return regeneratorRuntime.wrap(function _callee3$(_context8) {
    while (1) {
      switch (_context8.prev = _context8.next) {
        case 0:
          testCall = function _ref9() {
            return regeneratorRuntime.wrap(function testCall$(_context7) {
              while (1) {
                switch (_context7.prev = _context7.next) {
                  case 0:
                    _context7.next = 2;
                    return cmds.call(testCallee);

                  case 2:
                    return _context7.abrupt("return", _context7.sent);

                  case 3:
                  case "end":
                    return _context7.stop();
                }
              }
            }, _marked5, this);
          };

          testCallee = function _ref8() {
            return regeneratorRuntime.wrap(function testCallee$(_context6) {
              while (1) {
                switch (_context6.prev = _context6.next) {
                  case 0:
                    throw new Error("oops");

                  case 1:
                  case "end":
                    return _context6.stop();
                }
              }
            }, _marked4, this);
          };

          _marked4 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCallee), _marked5 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          _context8.prev = 3;
          _context8.next = 6;
          return promisify(testCall)();

        case 6:
          _context8.next = 12;
          break;

        case 8:
          _context8.prev = 8;
          _context8.t0 = _context8["catch"](3);
          expect(_context8.t0.message).toEqual("oops");
          return _context8.abrupt("return");

        case 12:
          throw new Error("testCall did not throw");

        case 13:
        case "end":
          return _context8.stop();
      }
    }
  }, _callee3, this, [[3, 8]]);
})));
test("callFn() should call a promise-returning function",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee4() {
  var _marked6, testCallee, testCall, actual, expected;

  return regeneratorRuntime.wrap(function _callee4$(_context10) {
    while (1) {
      switch (_context10.prev = _context10.next) {
        case 0:
          testCall = function _ref12() {
            return regeneratorRuntime.wrap(function testCall$(_context9) {
              while (1) {
                switch (_context9.prev = _context9.next) {
                  case 0:
                    _context9.next = 2;
                    return cmds.callFn(testCallee, "bar");

                  case 2:
                    return _context9.abrupt("return", _context9.sent);

                  case 3:
                  case "end":
                    return _context9.stop();
                }
              }
            }, _marked6, this);
          };

          testCallee = function _ref11(message) {
            return Promise.resolve("foo".concat(message));
          };

          _marked6 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          _context10.next = 5;
          return promisify(testCall)();

        case 5:
          actual = _context10.sent;
          expected = "foobar";
          expect(actual).toEqual(expected);

        case 8:
        case "end":
          return _context10.stop();
      }
    }
  }, _callee4, this);
})));
test("callFn() should call a non-promise-returning function",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee5() {
  var _marked7, testCallee, testCall, actual, expected;

  return regeneratorRuntime.wrap(function _callee5$(_context12) {
    while (1) {
      switch (_context12.prev = _context12.next) {
        case 0:
          testCall = function _ref15() {
            return regeneratorRuntime.wrap(function testCall$(_context11) {
              while (1) {
                switch (_context11.prev = _context11.next) {
                  case 0:
                    _context11.next = 2;
                    return cmds.callFn(testCallee, "bar");

                  case 2:
                    return _context11.abrupt("return", _context11.sent);

                  case 3:
                  case "end":
                    return _context11.stop();
                }
              }
            }, _marked7, this);
          };

          testCallee = function _ref14(message) {
            return "foo".concat(message);
          };

          _marked7 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          _context12.next = 5;
          return promisify(testCall)();

        case 5:
          actual = _context12.sent;
          expected = "foobar";
          expect(actual).toEqual(expected);

        case 8:
        case "end":
          return _context12.stop();
      }
    }
  }, _callee5, this);
})));
test("fn() should call a promise-returning function",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee6() {
  var _marked8, testCallee, testCall, actual, expected;

  return regeneratorRuntime.wrap(function _callee6$(_context14) {
    while (1) {
      switch (_context14.prev = _context14.next) {
        case 0:
          testCall = function _ref18() {
            return regeneratorRuntime.wrap(function testCall$(_context13) {
              while (1) {
                switch (_context13.prev = _context13.next) {
                  case 0:
                    _context13.next = 2;
                    return cmds.fn(testCallee, "bar");

                  case 2:
                    return _context13.abrupt("return", _context13.sent);

                  case 3:
                  case "end":
                    return _context13.stop();
                }
              }
            }, _marked8, this);
          };

          testCallee = function _ref17(message) {
            return Promise.resolve("foo".concat(message));
          };

          _marked8 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          _context14.next = 5;
          return promisify(testCall)();

        case 5:
          actual = _context14.sent;
          expected = "foobar";
          expect(actual).toEqual(expected);

        case 8:
        case "end":
          return _context14.stop();
      }
    }
  }, _callee6, this);
})));
test("callFn() should handle rejected promises",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee7() {
  var _marked9, testCallee, testCall;

  return regeneratorRuntime.wrap(function _callee7$(_context16) {
    while (1) {
      switch (_context16.prev = _context16.next) {
        case 0:
          testCall = function _ref21() {
            return regeneratorRuntime.wrap(function testCall$(_context15) {
              while (1) {
                switch (_context15.prev = _context15.next) {
                  case 0:
                    _context15.next = 2;
                    return cmds.callFn(testCallee, "bar");

                  case 2:
                    return _context15.abrupt("return", _context15.sent);

                  case 3:
                  case "end":
                    return _context15.stop();
                }
              }
            }, _marked9, this);
          };

          testCallee = function _ref20() {
            return Promise.reject(new Error("oops"));
          };

          _marked9 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          _context16.prev = 3;
          _context16.next = 6;
          return promisify(testCall)();

        case 6:
          _context16.next = 12;
          break;

        case 8:
          _context16.prev = 8;
          _context16.t0 = _context16["catch"](3);
          expect(_context16.t0.message).toEqual("oops");
          return _context16.abrupt("return");

        case 12:
          throw new Error("testCall did not reject");

        case 13:
        case "end":
          return _context16.stop();
      }
    }
  }, _callee7, this, [[3, 8]]);
})));
test("callFn() should handle errors",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee8() {
  var _marked10, testCallee, testCall;

  return regeneratorRuntime.wrap(function _callee8$(_context18) {
    while (1) {
      switch (_context18.prev = _context18.next) {
        case 0:
          testCall = function _ref24() {
            return regeneratorRuntime.wrap(function testCall$(_context17) {
              while (1) {
                switch (_context17.prev = _context17.next) {
                  case 0:
                    _context17.next = 2;
                    return cmds.callFn(testCallee, "bar");

                  case 2:
                    return _context17.abrupt("return", _context17.sent);

                  case 3:
                  case "end":
                    return _context17.stop();
                }
              }
            }, _marked10, this);
          };

          testCallee = function _ref23() {
            throw new Error("oops");
          };

          _marked10 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          _context18.prev = 3;
          _context18.next = 6;
          return promisify(testCall)();

        case 6:
          _context18.next = 12;
          break;

        case 8:
          _context18.prev = 8;
          _context18.t0 = _context18["catch"](3);
          expect(_context18.t0.message).toEqual("oops");
          return _context18.abrupt("return");

        case 12:
          throw new Error("testCall did not throw");

        case 13:
        case "end":
          return _context18.stop();
      }
    }
  }, _callee8, this, [[3, 8]]);
})));
test("callFnBound() should call a function with `this`",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee9() {
  var _marked11, context, testCallee, testCall, actual, expected;

  return regeneratorRuntime.wrap(function _callee9$(_context20) {
    while (1) {
      switch (_context20.prev = _context20.next) {
        case 0:
          testCall = function _ref27() {
            return regeneratorRuntime.wrap(function testCall$(_context19) {
              while (1) {
                switch (_context19.prev = _context19.next) {
                  case 0:
                    _context19.next = 2;
                    return cmds.callFnBound(context, testCallee);

                  case 2:
                    return _context19.abrupt("return", _context19.sent);

                  case 3:
                  case "end":
                    return _context19.stop();
                }
              }
            }, _marked11, this);
          };

          testCallee = function _ref26() {
            return Promise.resolve("foo".concat(this.message));
          };

          _marked11 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          context = {
            message: "bar"
          };
          _context20.next = 6;
          return promisify(testCall)();

        case 6:
          actual = _context20.sent;
          expected = "foobar";
          expect(actual).toEqual(expected);

        case 9:
        case "end":
          return _context20.stop();
      }
    }
  }, _callee9, this);
})));
test("callFnBound() should handle errors",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee10() {
  var _marked12, context, testCallee, testCall;

  return regeneratorRuntime.wrap(function _callee10$(_context22) {
    while (1) {
      switch (_context22.prev = _context22.next) {
        case 0:
          testCall = function _ref30() {
            return regeneratorRuntime.wrap(function testCall$(_context21) {
              while (1) {
                switch (_context21.prev = _context21.next) {
                  case 0:
                    _context21.next = 2;
                    return cmds.callFnBound(context, testCallee);

                  case 2:
                    return _context21.abrupt("return", _context21.sent);

                  case 3:
                  case "end":
                    return _context21.stop();
                }
              }
            }, _marked12, this);
          };

          testCallee = function _ref29() {
            throw new Error("oops");
          };

          _marked12 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          context = {
            message: "bar"
          };
          _context22.prev = 4;
          _context22.next = 7;
          return promisify(testCall)();

        case 7:
          _context22.next = 13;
          break;

        case 9:
          _context22.prev = 9;
          _context22.t0 = _context22["catch"](4);
          expect(_context22.t0.message).toEqual("oops");
          return _context22.abrupt("return");

        case 13:
          throw new Error("testCall did not throw");

        case 14:
        case "end":
          return _context22.stop();
      }
    }
  }, _callee10, this, [[4, 9]]);
})));
test("callCallback() should call a callback function",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee11() {
  var _marked13, testCallee, testCall, actual, expected;

  return regeneratorRuntime.wrap(function _callee11$(_context24) {
    while (1) {
      switch (_context24.prev = _context24.next) {
        case 0:
          testCall = function _ref33() {
            return regeneratorRuntime.wrap(function testCall$(_context23) {
              while (1) {
                switch (_context23.prev = _context23.next) {
                  case 0:
                    _context23.next = 2;
                    return cmds.callCallback(testCallee, "bar");

                  case 2:
                    return _context23.abrupt("return", _context23.sent);

                  case 3:
                  case "end":
                    return _context23.stop();
                }
              }
            }, _marked13, this);
          };

          testCallee = function _ref32(message, done) {
            done(null, "foo".concat(message));
          };

          _marked13 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          _context24.next = 5;
          return promisify(testCall)();

        case 5:
          actual = _context24.sent;
          expected = "foobar";
          expect(actual).toEqual(expected);

        case 8:
        case "end":
          return _context24.stop();
      }
    }
  }, _callee11, this);
})));
test("callback() should call a callback function",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee12() {
  var _marked14, testCallee, testCall, actual, expected;

  return regeneratorRuntime.wrap(function _callee12$(_context26) {
    while (1) {
      switch (_context26.prev = _context26.next) {
        case 0:
          testCall = function _ref36() {
            return regeneratorRuntime.wrap(function testCall$(_context25) {
              while (1) {
                switch (_context25.prev = _context25.next) {
                  case 0:
                    _context25.next = 2;
                    return cmds.callback(testCallee, "bar");

                  case 2:
                    return _context25.abrupt("return", _context25.sent);

                  case 3:
                  case "end":
                    return _context25.stop();
                }
              }
            }, _marked14, this);
          };

          testCallee = function _ref35(message, done) {
            done(null, "foo".concat(message));
          };

          _marked14 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          _context26.next = 5;
          return promisify(testCall)();

        case 5:
          actual = _context26.sent;
          expected = "foobar";
          expect(actual).toEqual(expected);

        case 8:
        case "end":
          return _context26.stop();
      }
    }
  }, _callee12, this);
})));
test("callCallback() should handle errors",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee13() {
  var _marked15, testCallee, testCall;

  return regeneratorRuntime.wrap(function _callee13$(_context28) {
    while (1) {
      switch (_context28.prev = _context28.next) {
        case 0:
          testCall = function _ref39() {
            return regeneratorRuntime.wrap(function testCall$(_context27) {
              while (1) {
                switch (_context27.prev = _context27.next) {
                  case 0:
                    _context27.next = 2;
                    return cmds.callCallback(testCallee);

                  case 2:
                    return _context27.abrupt("return", _context27.sent);

                  case 3:
                  case "end":
                    return _context27.stop();
                }
              }
            }, _marked15, this);
          };

          testCallee = function _ref38(done) {
            done(new Error("oops"));
          };

          _marked15 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          _context28.prev = 3;
          _context28.next = 6;
          return promisify(testCall)();

        case 6:
          _context28.next = 12;
          break;

        case 8:
          _context28.prev = 8;
          _context28.t0 = _context28["catch"](3);
          expect(_context28.t0.message).toEqual("oops");
          return _context28.abrupt("return");

        case 12:
          throw new Error("testCall did not throw");

        case 13:
        case "end":
          return _context28.stop();
      }
    }
  }, _callee13, this, [[3, 8]]);
})));
test("callCallback() should handle thrown errors",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee14() {
  var _marked16, testCallee, testCall;

  return regeneratorRuntime.wrap(function _callee14$(_context30) {
    while (1) {
      switch (_context30.prev = _context30.next) {
        case 0:
          testCall = function _ref42() {
            return regeneratorRuntime.wrap(function testCall$(_context29) {
              while (1) {
                switch (_context29.prev = _context29.next) {
                  case 0:
                    _context29.next = 2;
                    return cmds.callCallback(testCallee);

                  case 2:
                    return _context29.abrupt("return", _context29.sent);

                  case 3:
                  case "end":
                    return _context29.stop();
                }
              }
            }, _marked16, this);
          };

          testCallee = function _ref41(done) {
            throw new Error("oops");
          };

          _marked16 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          _context30.prev = 3;
          _context30.next = 6;
          return promisify(testCall)();

        case 6:
          _context30.next = 12;
          break;

        case 8:
          _context30.prev = 8;
          _context30.t0 = _context30["catch"](3);
          expect(_context30.t0.message).toEqual("oops");
          return _context30.abrupt("return");

        case 12:
          throw new Error("testCall did not throw");

        case 13:
        case "end":
          return _context30.stop();
      }
    }
  }, _callee14, this, [[3, 8]]);
})));
test("callCallbackBound() should call a callback function with `this`",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee15() {
  var _marked17, context, testCallee, testCall, actual, expected;

  return regeneratorRuntime.wrap(function _callee15$(_context32) {
    while (1) {
      switch (_context32.prev = _context32.next) {
        case 0:
          testCall = function _ref45() {
            return regeneratorRuntime.wrap(function testCall$(_context31) {
              while (1) {
                switch (_context31.prev = _context31.next) {
                  case 0:
                    _context31.next = 2;
                    return cmds.callCallbackBound(context, testCallee);

                  case 2:
                    return _context31.abrupt("return", _context31.sent);

                  case 3:
                  case "end":
                    return _context31.stop();
                }
              }
            }, _marked17, this);
          };

          testCallee = function _ref44(done) {
            done(null, "foo".concat(this.message));
          };

          _marked17 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          context = {
            message: "bar"
          };
          _context32.next = 6;
          return promisify(testCall)();

        case 6:
          actual = _context32.sent;
          expected = "foobar";
          expect(actual).toEqual(expected);

        case 9:
        case "end":
          return _context32.stop();
      }
    }
  }, _callee15, this);
})));
test("callCallbackBound() should handle errors",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee16() {
  var _marked18, context, testCallee, testCall;

  return regeneratorRuntime.wrap(function _callee16$(_context34) {
    while (1) {
      switch (_context34.prev = _context34.next) {
        case 0:
          testCall = function _ref48() {
            return regeneratorRuntime.wrap(function testCall$(_context33) {
              while (1) {
                switch (_context33.prev = _context33.next) {
                  case 0:
                    _context33.next = 2;
                    return cmds.callCallbackBound(context, testCallee);

                  case 2:
                    return _context33.abrupt("return", _context33.sent);

                  case 3:
                  case "end":
                    return _context33.stop();
                }
              }
            }, _marked18, this);
          };

          testCallee = function _ref47(done) {
            done(new Error("oops"));
          };

          _marked18 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          context = {
            message: "bar"
          };
          _context34.prev = 4;
          _context34.next = 7;
          return promisify(testCall)();

        case 7:
          _context34.next = 13;
          break;

        case 9:
          _context34.prev = 9;
          _context34.t0 = _context34["catch"](4);
          expect(_context34.t0.message).toEqual("oops");
          return _context34.abrupt("return");

        case 13:
          throw new Error("testCall did not throw");

        case 14:
        case "end":
          return _context34.stop();
      }
    }
  }, _callee16, this, [[4, 9]]);
})));
test("callCallbackBound() should handle thrown errors",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee17() {
  var _marked19, context, testCallee, testCall;

  return regeneratorRuntime.wrap(function _callee17$(_context36) {
    while (1) {
      switch (_context36.prev = _context36.next) {
        case 0:
          testCall = function _ref51() {
            return regeneratorRuntime.wrap(function testCall$(_context35) {
              while (1) {
                switch (_context35.prev = _context35.next) {
                  case 0:
                    _context35.next = 2;
                    return cmds.callCallbackBound(context, testCallee);

                  case 2:
                    return _context35.abrupt("return", _context35.sent);

                  case 3:
                  case "end":
                    return _context35.stop();
                }
              }
            }, _marked19, this);
          };

          testCallee = function _ref50(done) {
            throw new Error("oops");
          };

          _marked19 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          context = {
            message: "bar"
          };
          _context36.prev = 4;
          _context36.next = 7;
          return promisify(testCall)();

        case 7:
          _context36.next = 13;
          break;

        case 9:
          _context36.prev = 9;
          _context36.t0 = _context36["catch"](4);
          expect(_context36.t0.message).toEqual("oops");
          return _context36.abrupt("return");

        case 13:
          throw new Error("testCall did not throw");

        case 14:
        case "end":
          return _context36.stop();
      }
    }
  }, _callee17, this, [[4, 9]]);
})));
test("echo() should return the echoed value",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee18() {
  var _marked20, testCall, actual, expected;

  return regeneratorRuntime.wrap(function _callee18$(_context38) {
    while (1) {
      switch (_context38.prev = _context38.next) {
        case 0:
          testCall = function _ref53() {
            return regeneratorRuntime.wrap(function testCall$(_context37) {
              while (1) {
                switch (_context37.prev = _context37.next) {
                  case 0:
                    _context37.next = 2;
                    return cmds.echo("foobar");

                  case 2:
                    return _context37.abrupt("return", _context37.sent);

                  case 3:
                  case "end":
                    return _context37.stop();
                }
              }
            }, _marked20, this);
          };

          _marked20 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          _context38.next = 4;
          return promisify(testCall)();

        case 4:
          actual = _context38.sent;
          expected = "foobar";
          expect(actual).toEqual(expected);

        case 7:
        case "end":
          return _context38.stop();
      }
    }
  }, _callee18, this);
})));
test("noop() should noop",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee19() {
  var _marked21, testCall, actual, expected;

  return regeneratorRuntime.wrap(function _callee19$(_context40) {
    while (1) {
      switch (_context40.prev = _context40.next) {
        case 0:
          testCall = function _ref55() {
            return regeneratorRuntime.wrap(function testCall$(_context39) {
              while (1) {
                switch (_context39.prev = _context39.next) {
                  case 0:
                    _context39.next = 2;
                    return cmds.noop();

                  case 2:
                    return _context39.abrupt("return", _context39.sent);

                  case 3:
                  case "end":
                    return _context39.stop();
                }
              }
            }, _marked21, this);
          };

          _marked21 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          _context40.next = 4;
          return promisify(testCall)();

        case 4:
          actual = _context40.sent;
          expected = undefined;
          expect(actual).toEqual(expected);

        case 7:
        case "end":
          return _context40.stop();
      }
    }
  }, _callee19, this);
})));
test("now() should return a timestamp",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee20() {
  var _marked22, now, testCall, actual;

  return regeneratorRuntime.wrap(function _callee20$(_context42) {
    while (1) {
      switch (_context42.prev = _context42.next) {
        case 0:
          testCall = function _ref57() {
            return regeneratorRuntime.wrap(function testCall$(_context41) {
              while (1) {
                switch (_context41.prev = _context41.next) {
                  case 0:
                    _context41.next = 2;
                    return cmds.now();

                  case 2:
                    return _context41.abrupt("return", _context41.sent);

                  case 3:
                  case "end":
                    return _context41.stop();
                }
              }
            }, _marked22, this);
          };

          _marked22 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          now = Date.now();
          _context42.next = 5;
          return promisify(testCall)();

        case 5:
          actual = _context42.sent;
          expect(actual - now).toBeLessThan(2);

        case 7:
        case "end":
          return _context42.stop();
      }
    }
  }, _callee20, this);
})));
test("log() should log to the console",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee21() {
  var _marked23, logOrig, actual, testCall, expected;

  return regeneratorRuntime.wrap(function _callee21$(_context44) {
    while (1) {
      switch (_context44.prev = _context44.next) {
        case 0:
          testCall = function _ref59() {
            return regeneratorRuntime.wrap(function testCall$(_context43) {
              while (1) {
                switch (_context43.prev = _context43.next) {
                  case 0:
                    _context43.next = 2;
                    return cmds.log("foo", "bar");

                  case 2:
                    return _context43.abrupt("return", _context43.sent);

                  case 3:
                  case "end":
                    return _context43.stop();
                }
              }
            }, _marked23, this);
          };

          _marked23 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          logOrig = console.log;

          console.log = function () {
            for (var _len = arguments.length, values = new Array(_len), _key = 0; _key < _len; _key++) {
              values[_key] = arguments[_key];
            }

            actual = values;
          };

          _context44.next = 6;
          return promisify(testCall)();

        case 6:
          console.log = logOrig;
          expected = ["foo", "bar"];
          expect(actual).toEqual(expected);

        case 9:
        case "end":
          return _context44.stop();
      }
    }
  }, _callee21, this);
})));
test("logError() should log to the console",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee22() {
  var _marked24, logOrig, actual, testCall, expected;

  return regeneratorRuntime.wrap(function _callee22$(_context46) {
    while (1) {
      switch (_context46.prev = _context46.next) {
        case 0:
          testCall = function _ref61() {
            return regeneratorRuntime.wrap(function testCall$(_context45) {
              while (1) {
                switch (_context45.prev = _context45.next) {
                  case 0:
                    _context45.next = 2;
                    return cmds.logError("foo", "bar");

                  case 2:
                    return _context45.abrupt("return", _context45.sent);

                  case 3:
                  case "end":
                    return _context45.stop();
                }
              }
            }, _marked24, this);
          };

          _marked24 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          logOrig = console.error;

          console.error = function () {
            for (var _len2 = arguments.length, values = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
              values[_key2] = arguments[_key2];
            }

            actual = values;
          };

          _context46.next = 6;
          return promisify(testCall)();

        case 6:
          console.error = logOrig;
          expected = ["foo", "bar"];
          expect(actual).toEqual(expected);

        case 9:
        case "end":
          return _context46.stop();
      }
    }
  }, _callee22, this);
})));
test("sleep() should sleep",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee23() {
  var _marked25, start, testCall, actual, end;

  return regeneratorRuntime.wrap(function _callee23$(_context48) {
    while (1) {
      switch (_context48.prev = _context48.next) {
        case 0:
          testCall = function _ref63() {
            return regeneratorRuntime.wrap(function testCall$(_context47) {
              while (1) {
                switch (_context47.prev = _context47.next) {
                  case 0:
                    _context47.next = 2;
                    return cmds.sleep(100);

                  case 2:
                    return _context47.abrupt("return", _context47.sent);

                  case 3:
                  case "end":
                    return _context47.stop();
                }
              }
            }, _marked25, this);
          };

          _marked25 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          start = Date.now();
          _context48.next = 5;
          return promisify(testCall)();

        case 5:
          actual = _context48.sent;
          end = Date.now();
          expect(end - start).toBeGreaterThanOrEqual(100);

        case 8:
        case "end":
          return _context48.stop();
      }
    }
  }, _callee23, this);
})));
test("series() should execute in series",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee24() {
  var _marked26, start, testCall, actual, end;

  return regeneratorRuntime.wrap(function _callee24$(_context50) {
    while (1) {
      switch (_context50.prev = _context50.next) {
        case 0:
          testCall = function _ref65() {
            return regeneratorRuntime.wrap(function testCall$(_context49) {
              while (1) {
                switch (_context49.prev = _context49.next) {
                  case 0:
                    _context49.next = 2;
                    return cmds.series([cmds.sleep(50), cmds.sleep(50), cmds.sleep(50)]);

                  case 2:
                    return _context49.abrupt("return", _context49.sent);

                  case 3:
                  case "end":
                    return _context49.stop();
                }
              }
            }, _marked26, this);
          };

          _marked26 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          start = Date.now();
          _context50.next = 5;
          return promisify(testCall)();

        case 5:
          actual = _context50.sent;
          end = Date.now();
          expect(end - start).toBeGreaterThanOrEqual(150);

        case 8:
        case "end":
          return _context50.stop();
      }
    }
  }, _callee24, this);
})));
test("series() should handle an empty list",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee25() {
  var _marked27, testCall, actual;

  return regeneratorRuntime.wrap(function _callee25$(_context52) {
    while (1) {
      switch (_context52.prev = _context52.next) {
        case 0:
          testCall = function _ref67() {
            return regeneratorRuntime.wrap(function testCall$(_context51) {
              while (1) {
                switch (_context51.prev = _context51.next) {
                  case 0:
                    _context51.next = 2;
                    return cmds.series([]);

                  case 2:
                    return _context51.abrupt("return", _context51.sent);

                  case 3:
                  case "end":
                    return _context51.stop();
                }
              }
            }, _marked27, this);
          };

          _marked27 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          _context52.next = 4;
          return promisify(testCall)();

        case 4:
          actual = _context52.sent;
          expect(actual).toEqual([]);

        case 6:
        case "end":
          return _context52.stop();
      }
    }
  }, _callee25, this);
})));
test("parellel() should execute in parellel",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee26() {
  var _marked28, start, testCall, actual, end;

  return regeneratorRuntime.wrap(function _callee26$(_context54) {
    while (1) {
      switch (_context54.prev = _context54.next) {
        case 0:
          testCall = function _ref69() {
            return regeneratorRuntime.wrap(function testCall$(_context53) {
              while (1) {
                switch (_context53.prev = _context53.next) {
                  case 0:
                    _context53.next = 2;
                    return cmds.parallel([cmds.sleep(50), cmds.sleep(50), cmds.sleep(50)]);

                  case 2:
                    return _context53.abrupt("return", _context53.sent);

                  case 3:
                  case "end":
                    return _context53.stop();
                }
              }
            }, _marked28, this);
          };

          _marked28 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          start = Date.now();
          _context54.next = 5;
          return promisify(testCall)();

        case 5:
          actual = _context54.sent;
          end = Date.now();
          expect(end - start).toBeGreaterThanOrEqual(50);
          expect(end - start).toBeLessThan(60);

        case 9:
        case "end":
          return _context54.stop();
      }
    }
  }, _callee26, this);
})));
test("envelope() should return success results in an envelope",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee27() {
  var _marked29, _marked30, testCallee, testCall, actual, expected;

  return regeneratorRuntime.wrap(function _callee27$(_context57) {
    while (1) {
      switch (_context57.prev = _context57.next) {
        case 0:
          testCall = function _ref72() {
            return regeneratorRuntime.wrap(function testCall$(_context56) {
              while (1) {
                switch (_context56.prev = _context56.next) {
                  case 0:
                    _context56.next = 2;
                    return cmds.envelope(cmds.call(testCallee, "bar"));

                  case 2:
                    return _context56.abrupt("return", _context56.sent);

                  case 3:
                  case "end":
                    return _context56.stop();
                }
              }
            }, _marked30, this);
          };

          testCallee = function _ref71(message) {
            return regeneratorRuntime.wrap(function testCallee$(_context55) {
              while (1) {
                switch (_context55.prev = _context55.next) {
                  case 0:
                    _context55.next = 2;
                    return cmds.echo("foo".concat(message));

                  case 2:
                    return _context55.abrupt("return", _context55.sent);

                  case 3:
                  case "end":
                    return _context55.stop();
                }
              }
            }, _marked29, this);
          };

          _marked29 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCallee), _marked30 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          _context57.next = 5;
          return promisify(testCall)();

        case 5:
          actual = _context57.sent;
          expected = {
            success: true,
            result: "foobar"
          };
          expect(actual).toEqual(expected);

        case 8:
        case "end":
          return _context57.stop();
      }
    }
  }, _callee27, this);
})));
test("envelope() should return failed results in an envelope",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee28() {
  var _marked31, _marked32, testCallee, testCall, actual;

  return regeneratorRuntime.wrap(function _callee28$(_context60) {
    while (1) {
      switch (_context60.prev = _context60.next) {
        case 0:
          testCall = function _ref75() {
            return regeneratorRuntime.wrap(function testCall$(_context59) {
              while (1) {
                switch (_context59.prev = _context59.next) {
                  case 0:
                    _context59.next = 2;
                    return cmds.envelope(cmds.call(testCallee, "bar"));

                  case 2:
                    return _context59.abrupt("return", _context59.sent);

                  case 3:
                  case "end":
                    return _context59.stop();
                }
              }
            }, _marked32, this);
          };

          testCallee = function _ref74(message) {
            return regeneratorRuntime.wrap(function testCallee$(_context58) {
              while (1) {
                switch (_context58.prev = _context58.next) {
                  case 0:
                    throw new Error("oops");

                  case 1:
                  case "end":
                    return _context58.stop();
                }
              }
            }, _marked31, this);
          };

          _marked31 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCallee), _marked32 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          _context60.next = 5;
          return promisify(testCall)();

        case 5:
          actual = _context60.sent;
          expect(actual.success).toEqual(false);
          expect(actual.result.message).toEqual("oops");

        case 8:
        case "end":
          return _context60.stop();
      }
    }
  }, _callee28, this);
})));
test("either() should return value on success",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee29() {
  var _marked33, testCall, actual, expected;

  return regeneratorRuntime.wrap(function _callee29$(_context62) {
    while (1) {
      switch (_context62.prev = _context62.next) {
        case 0:
          testCall = function _ref77() {
            return regeneratorRuntime.wrap(function testCall$(_context61) {
              while (1) {
                switch (_context61.prev = _context61.next) {
                  case 0:
                    _context61.next = 2;
                    return cmds.either(cmds.echo("foobar"), null);

                  case 2:
                    return _context61.abrupt("return", _context61.sent);

                  case 3:
                  case "end":
                    return _context61.stop();
                }
              }
            }, _marked33, this);
          };

          _marked33 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          _context62.next = 4;
          return promisify(testCall)();

        case 4:
          actual = _context62.sent;
          expected = "foobar";
          expect(actual).toEqual(expected);

        case 7:
        case "end":
          return _context62.stop();
      }
    }
  }, _callee29, this);
})));
test("either() should return default value on error",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee30() {
  var _marked34, _marked35, testCallee, testCall, actual, expected;

  return regeneratorRuntime.wrap(function _callee30$(_context65) {
    while (1) {
      switch (_context65.prev = _context65.next) {
        case 0:
          testCall = function _ref80() {
            return regeneratorRuntime.wrap(function testCall$(_context64) {
              while (1) {
                switch (_context64.prev = _context64.next) {
                  case 0:
                    _context64.next = 2;
                    return cmds.either(cmds.call(testCallee), "defaultvalue");

                  case 2:
                    return _context64.abrupt("return", _context64.sent);

                  case 3:
                  case "end":
                    return _context64.stop();
                }
              }
            }, _marked35, this);
          };

          testCallee = function _ref79() {
            return regeneratorRuntime.wrap(function testCallee$(_context63) {
              while (1) {
                switch (_context63.prev = _context63.next) {
                  case 0:
                    throw new Error("oops");

                  case 1:
                  case "end":
                    return _context63.stop();
                }
              }
            }, _marked34, this);
          };

          _marked34 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCallee), _marked35 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          _context65.next = 5;
          return promisify(testCall)();

        case 5:
          actual = _context65.sent;
          expected = "defaultvalue";
          expect(actual).toEqual(expected);

        case 8:
        case "end":
          return _context65.stop();
      }
    }
  }, _callee30, this);
})));
test('setImmediate() should process a command "immediately"',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee31() {
  var _marked36, _marked37, actual, testCallee, testCall;

  return regeneratorRuntime.wrap(function _callee31$(_context68) {
    while (1) {
      switch (_context68.prev = _context68.next) {
        case 0:
          testCall = function _ref83() {
            return regeneratorRuntime.wrap(function testCall$(_context67) {
              while (1) {
                switch (_context67.prev = _context67.next) {
                  case 0:
                    _context67.next = 2;
                    return cmds.setImmediate(cmds.call(testCallee, "foobar"));

                  case 2:
                  case "end":
                    return _context67.stop();
                }
              }
            }, _marked37, this);
          };

          testCallee = function _ref82(message) {
            return regeneratorRuntime.wrap(function testCallee$(_context66) {
              while (1) {
                switch (_context66.prev = _context66.next) {
                  case 0:
                    actual = message;

                  case 1:
                  case "end":
                    return _context66.stop();
                }
              }
            }, _marked36, this);
          };

          _marked36 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCallee), _marked37 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          _context68.next = 5;
          return promisify(testCall)();

        case 5:
          expect(actual).toEqual(undefined);
          _context68.next = 8;
          return sleep(10);

        case 8:
          expect(actual).toEqual("foobar");

        case 9:
        case "end":
          return _context68.stop();
      }
    }
  }, _callee31, this);
})));
test("setTimeout() should set a timeout",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee32() {
  var _marked38, _marked39, actual, testCallee, testCall;

  return regeneratorRuntime.wrap(function _callee32$(_context71) {
    while (1) {
      switch (_context71.prev = _context71.next) {
        case 0:
          testCall = function _ref86() {
            return regeneratorRuntime.wrap(function testCall$(_context70) {
              while (1) {
                switch (_context70.prev = _context70.next) {
                  case 0:
                    _context70.next = 2;
                    return cmds.setTimeout(cmds.call(testCallee, "foobar"), 10);

                  case 2:
                  case "end":
                    return _context70.stop();
                }
              }
            }, _marked39, this);
          };

          testCallee = function _ref85(message) {
            return regeneratorRuntime.wrap(function testCallee$(_context69) {
              while (1) {
                switch (_context69.prev = _context69.next) {
                  case 0:
                    actual = message;

                  case 1:
                  case "end":
                    return _context69.stop();
                }
              }
            }, _marked38, this);
          };

          _marked38 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCallee), _marked39 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          _context71.next = 5;
          return promisify(testCall)();

        case 5:
          _context71.next = 7;
          return sleep(5);

        case 7:
          expect(actual).toEqual(undefined);
          _context71.next = 10;
          return sleep(12);

        case 10:
          expect(actual).toEqual("foobar");

        case 11:
        case "end":
          return _context71.stop();
      }
    }
  }, _callee32, this);
})));
test("clearTimeout() should clear a timeout",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee33() {
  var _marked40, _marked41, actual, testCallee, testCall;

  return regeneratorRuntime.wrap(function _callee33$(_context74) {
    while (1) {
      switch (_context74.prev = _context74.next) {
        case 0:
          testCall = function _ref89() {
            var id;
            return regeneratorRuntime.wrap(function testCall$(_context73) {
              while (1) {
                switch (_context73.prev = _context73.next) {
                  case 0:
                    _context73.next = 2;
                    return cmds.setTimeout(cmds.call(testCallee, "foobar"), 10);

                  case 2:
                    id = _context73.sent;
                    _context73.next = 5;
                    return cmds.clearTimeout(id);

                  case 5:
                  case "end":
                    return _context73.stop();
                }
              }
            }, _marked41, this);
          };

          testCallee = function _ref88(message) {
            return regeneratorRuntime.wrap(function testCallee$(_context72) {
              while (1) {
                switch (_context72.prev = _context72.next) {
                  case 0:
                    actual = message;

                  case 1:
                  case "end":
                    return _context72.stop();
                }
              }
            }, _marked40, this);
          };

          _marked40 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCallee), _marked41 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          _context74.next = 5;
          return promisify(testCall)();

        case 5:
          _context74.next = 7;
          return sleep(5);

        case 7:
          expect(actual).toEqual(undefined);
          _context74.next = 10;
          return sleep(12);

        case 10:
          expect(actual).toEqual(undefined);

        case 11:
        case "end":
          return _context74.stop();
      }
    }
  }, _callee33, this);
})));
test("setInterval() should set an interval",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee34() {
  var _marked42, _marked43, actual, id, testCallee, testCall;

  return regeneratorRuntime.wrap(function _callee34$(_context77) {
    while (1) {
      switch (_context77.prev = _context77.next) {
        case 0:
          testCall = function _ref92() {
            return regeneratorRuntime.wrap(function testCall$(_context76) {
              while (1) {
                switch (_context76.prev = _context76.next) {
                  case 0:
                    _context76.next = 2;
                    return cmds.setInterval(cmds.call(testCallee), 5);

                  case 2:
                    id = _context76.sent;

                  case 3:
                  case "end":
                    return _context76.stop();
                }
              }
            }, _marked43, this);
          };

          testCallee = function _ref91() {
            return regeneratorRuntime.wrap(function testCallee$(_context75) {
              while (1) {
                switch (_context75.prev = _context75.next) {
                  case 0:
                    actual++;

                  case 1:
                  case "end":
                    return _context75.stop();
                }
              }
            }, _marked42, this);
          };

          _marked42 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCallee), _marked43 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          actual = 0;
          _context77.next = 6;
          return promisify(testCall)();

        case 6:
          expect(actual).toEqual(0);
          _context77.next = 9;
          return sleep(10);

        case 9:
          expect(actual).toBeGreaterThanOrEqual(1);
          _context77.next = 12;
          return sleep(20);

        case 12:
          expect(actual).toBeGreaterThanOrEqual(3);
          clearInterval(id);

        case 14:
        case "end":
          return _context77.stop();
      }
    }
  }, _callee34, this);
})));
test("clearInterval() should set an interval",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee35() {
  var _marked44, _marked45, actual, testCallee, testCall;

  return regeneratorRuntime.wrap(function _callee35$(_context80) {
    while (1) {
      switch (_context80.prev = _context80.next) {
        case 0:
          testCall = function _ref95() {
            var id;
            return regeneratorRuntime.wrap(function testCall$(_context79) {
              while (1) {
                switch (_context79.prev = _context79.next) {
                  case 0:
                    _context79.next = 2;
                    return cmds.setInterval(cmds.call(testCallee), 5);

                  case 2:
                    id = _context79.sent;
                    _context79.next = 5;
                    return cmds.clearInterval(id);

                  case 5:
                  case "end":
                    return _context79.stop();
                }
              }
            }, _marked45, this);
          };

          testCallee = function _ref94() {
            return regeneratorRuntime.wrap(function testCallee$(_context78) {
              while (1) {
                switch (_context78.prev = _context78.next) {
                  case 0:
                    actual++;

                  case 1:
                  case "end":
                    return _context78.stop();
                }
              }
            }, _marked44, this);
          };

          _marked44 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCallee), _marked45 =
          /*#__PURE__*/
          regeneratorRuntime.mark(testCall);
          actual = 0;
          _context80.next = 6;
          return promisify(testCall)();

        case 6:
          expect(actual).toEqual(0);
          _context80.next = 9;
          return sleep(10);

        case 9:
          expect(actual).toEqual(0);
          _context80.next = 12;
          return sleep(20);

        case 12:
          expect(actual).toEqual(0);

        case 13:
        case "end":
          return _context80.stop();
      }
    }
  }, _callee35, this);
})));
test("getState()/setState() should get and set state",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee36() {
  var _marked46, t, value;

  return regeneratorRuntime.wrap(function _callee36$(_context82) {
    while (1) {
      switch (_context82.prev = _context82.next) {
        case 0:
          t = function _ref97() {
            return regeneratorRuntime.wrap(function t$(_context81) {
              while (1) {
                switch (_context81.prev = _context81.next) {
                  case 0:
                    _context81.next = 2;
                    return cmds.clearState();

                  case 2:
                    _context81.next = 4;
                    return cmds.setState("lorem1", "ipsum1");

                  case 4:
                    _context81.next = 6;
                    return cmds.setState("lorem2", "ipsum2");

                  case 6:
                    _context81.next = 8;
                    return [cmds.getState("lorem1"), cmds.getState("lorem2")];

                  case 8:
                    return _context81.abrupt("return", _context81.sent);

                  case 9:
                  case "end":
                    return _context81.stop();
                }
              }
            }, _marked46, this);
          };

          _marked46 =
          /*#__PURE__*/
          regeneratorRuntime.mark(t);
          _context82.next = 4;
          return promisify(t)();

        case 4:
          value = _context82.sent;
          expect(value).toEqual(["ipsum1", "ipsum2"]);

        case 6:
        case "end":
          return _context82.stop();
      }
    }
  }, _callee36, this);
})));
test("getState() should return entire state if no key",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee37() {
  var _marked47, t, state;

  return regeneratorRuntime.wrap(function _callee37$(_context84) {
    while (1) {
      switch (_context84.prev = _context84.next) {
        case 0:
          t = function _ref99() {
            return regeneratorRuntime.wrap(function t$(_context83) {
              while (1) {
                switch (_context83.prev = _context83.next) {
                  case 0:
                    _context83.next = 2;
                    return cmds.clearState();

                  case 2:
                    _context83.next = 4;
                    return cmds.setState("dolor", "sit");

                  case 4:
                    _context83.next = 6;
                    return cmds.getState();

                  case 6:
                    return _context83.abrupt("return", _context83.sent);

                  case 7:
                  case "end":
                    return _context83.stop();
                }
              }
            }, _marked47, this);
          };

          _marked47 =
          /*#__PURE__*/
          regeneratorRuntime.mark(t);
          _context84.next = 4;
          return promisify(t)();

        case 4:
          state = _context84.sent;
          expect(state).toEqual({
            dolor: "sit"
          });

        case 6:
        case "end":
          return _context84.stop();
      }
    }
  }, _callee37, this);
})));
test("getState() should use default value if value is undefined",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee38() {
  var _marked48, t, value;

  return regeneratorRuntime.wrap(function _callee38$(_context86) {
    while (1) {
      switch (_context86.prev = _context86.next) {
        case 0:
          t = function _ref101() {
            return regeneratorRuntime.wrap(function t$(_context85) {
              while (1) {
                switch (_context85.prev = _context85.next) {
                  case 0:
                    _context85.next = 2;
                    return cmds.clearState();

                  case 2:
                    _context85.next = 4;
                    return cmds.getState("amet", "consectetur");

                  case 4:
                    return _context85.abrupt("return", _context85.sent);

                  case 5:
                  case "end":
                    return _context85.stop();
                }
              }
            }, _marked48, this);
          };

          _marked48 =
          /*#__PURE__*/
          regeneratorRuntime.mark(t);
          _context86.next = 4;
          return promisify(t)();

        case 4:
          value = _context86.sent;
          expect(value).toEqual("consectetur");

        case 6:
        case "end":
          return _context86.stop();
      }
    }
  }, _callee38, this);
})));
test("clearState() should clear the state",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee39() {
  var _marked49, t, state;

  return regeneratorRuntime.wrap(function _callee39$(_context88) {
    while (1) {
      switch (_context88.prev = _context88.next) {
        case 0:
          t = function _ref103() {
            var state;
            return regeneratorRuntime.wrap(function t$(_context87) {
              while (1) {
                switch (_context87.prev = _context87.next) {
                  case 0:
                    _context87.next = 2;
                    return cmds.setState("adipiscing", "elit");

                  case 2:
                    _context87.next = 4;
                    return cmds.getState();

                  case 4:
                    state = _context87.sent;
                    expect(state).toEqual({
                      adipiscing: "elit"
                    });
                    _context87.next = 8;
                    return cmds.clearState();

                  case 8:
                    _context87.next = 10;
                    return cmds.getState();

                  case 10:
                    return _context87.abrupt("return", _context87.sent);

                  case 11:
                  case "end":
                    return _context87.stop();
                }
              }
            }, _marked49, this);
          };

          _marked49 =
          /*#__PURE__*/
          regeneratorRuntime.mark(t);
          _context88.next = 4;
          return promisify(t)();

        case 4:
          state = _context88.sent;
          expect(state).toEqual({});

        case 6:
        case "end":
          return _context88.stop();
      }
    }
  }, _callee39, this);
})));
//# sourceMappingURL=core-cmds-interpreters.spec.js.map