"use strict";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _marked =
/*#__PURE__*/
regeneratorRuntime.mark(throwInFn),
    _marked2 =
/*#__PURE__*/
regeneratorRuntime.mark(throwAtYield),
    _marked3 =
/*#__PURE__*/
regeneratorRuntime.mark(throwAtYieldRecovery);

var _require = require("../core"),
    call = _require.call;

var _require2 = require("./common"),
    interpreters = _require2.interpreters,
    functions = _require2.functions,
    cmds = _require2.cmds;

var usesThrowingInterpreter = functions.usesThrowingInterpreter,
    thrower = functions.thrower;

var _require3 = require("./test-util"),
    expectErrorEquality = _require3.expectErrorEquality;

function throwInFn() {
  return regeneratorRuntime.wrap(function throwInFn$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          throw new Error("oops!");

        case 1:
        case "end":
          return _context.stop();
      }
    }
  }, _marked, this);
}

function throwAtYield() {
  return regeneratorRuntime.wrap(function throwAtYield$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          _context2.prev = 0;
          _context2.next = 3;
          return cmds.die();

        case 3:
          _context2.next = 8;
          break;

        case 5:
          _context2.prev = 5;
          _context2.t0 = _context2["catch"](0);
          return _context2.abrupt("return", "caught!");

        case 8:
          return _context2.abrupt("return", "not caught");

        case 9:
        case "end":
          return _context2.stop();
      }
    }
  }, _marked2, this, [[0, 5]]);
}

function throwAtYieldRecovery() {
  return regeneratorRuntime.wrap(function throwAtYieldRecovery$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          _context3.prev = 0;
          _context3.next = 3;
          return cmds.die();

        case 3:
          _context3.next = 7;
          break;

        case 5:
          _context3.prev = 5;
          _context3.t0 = _context3["catch"](0);

        case 7:
          _context3.next = 9;
          return cmds.echo("foo");

        case 9:
          return _context3.abrupt("return", _context3.sent);

        case 10:
        case "end":
          return _context3.stop();
      }
    }
  }, _marked3, this, [[0, 5]]);
}

test("call should catch function errors",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee() {
  var message;
  return regeneratorRuntime.wrap(function _callee$(_context4) {
    while (1) {
      switch (_context4.prev = _context4.next) {
        case 0:
          _context4.prev = 0;
          _context4.next = 3;
          return call({}, interpreters, throwInFn);

        case 3:
          _context4.next = 9;
          break;

        case 5:
          _context4.prev = 5;
          _context4.t0 = _context4["catch"](0);
          message = "oops!";
          return _context4.abrupt("return", expectErrorEquality(_context4.t0, message));

        case 9:
          fail("Function did not reject.");

        case 10:
        case "end":
          return _context4.stop();
      }
    }
  }, _callee, this, [[0, 5]]);
})));
test("call should throw error at the yield",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee2() {
  var actual, expected;
  return regeneratorRuntime.wrap(function _callee2$(_context5) {
    while (1) {
      switch (_context5.prev = _context5.next) {
        case 0:
          _context5.next = 2;
          return call({}, interpreters, throwAtYield);

        case 2:
          actual = _context5.sent;
          expected = "caught!";
          expect(actual).toEqual(expected);

        case 5:
        case "end":
          return _context5.stop();
      }
    }
  }, _callee2, this);
})));
test("call should reject error at the yield and recover",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee3() {
  var actual, expected;
  return regeneratorRuntime.wrap(function _callee3$(_context6) {
    while (1) {
      switch (_context6.prev = _context6.next) {
        case 0:
          _context6.next = 2;
          return call({}, interpreters, throwAtYieldRecovery);

        case 2:
          actual = _context6.sent;
          expected = "foo";
          expect(actual).toEqual(expected);

        case 5:
        case "end":
          return _context6.stop();
      }
    }
  }, _callee3, this);
})));
test("call should reject error for unregistered interpreter",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee4() {
  var fn;
  return regeneratorRuntime.wrap(function _callee4$(_context8) {
    while (1) {
      switch (_context8.prev = _context8.next) {
        case 0:
          fn =
          /*#__PURE__*/
          regeneratorRuntime.mark(function fn() {
            return regeneratorRuntime.wrap(function fn$(_context7) {
              while (1) {
                switch (_context7.prev = _context7.next) {
                  case 0:
                    _context7.next = 2;
                    return {
                      type: "dne"
                    };

                  case 2:
                  case "end":
                    return _context7.stop();
                }
              }
            }, fn, this);
          });
          _context8.prev = 1;
          _context8.next = 4;
          return call({}, interpreters, fn);

        case 4:
          _context8.next = 10;
          break;

        case 6:
          _context8.prev = 6;
          _context8.t0 = _context8["catch"](1);
          expect(_context8.t0.message).toEqual('Interpreter of type "dne" is not registered.');
          return _context8.abrupt("return");

        case 10:
          fail("Did not throw.");

        case 11:
        case "end":
          return _context8.stop();
      }
    }
  }, _callee4, this, [[1, 6]]);
})));
//# sourceMappingURL=errors.spec.js.map