"use strict";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _require = require("../index"),
    promisify = _require.promisify,
    call = _require.call,
    doCmd = _require.doCmd,
    setContext = _require.setContext,
    getContext = _require.getContext,
    addToContext = _require.addToContext,
    setInterpreters = _require.setInterpreters,
    getInterpreters = _require.getInterpreters,
    addInterpreters = _require.addInterpreters,
    reset = _require.reset,
    onError = _require.onError,
    effect = _require.effect,
    cmds = _require.cmds,
    interpreters = _require.interpreters;

test("promisify should tag function", function () {
  var _marked =
  /*#__PURE__*/
  regeneratorRuntime.mark(test1);

  function test1(message) {
    return regeneratorRuntime.wrap(function test1$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return cmds.echo(message);

          case 2:
            return _context.abrupt("return", _context.sent);

          case 3:
          case "end":
            return _context.stop();
        }
      }
    }, _marked, this);
  }

  expect(promisify(test1).eadPromisified).toEqual(true);
});
test("promisify should name function", function () {
  var _marked2 =
  /*#__PURE__*/
  regeneratorRuntime.mark(testName);

  function testName(message) {
    return regeneratorRuntime.wrap(function testName$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return cmds.echo(message);

          case 2:
            return _context2.abrupt("return", _context2.sent);

          case 3:
          case "end":
            return _context2.stop();
        }
      }
    }, _marked2, this);
  }

  expect(promisify(testName).name).toEqual("testName");
});
test("promisify should not double wrap", function () {
  var _marked3 =
  /*#__PURE__*/
  regeneratorRuntime.mark(test1);

  function test1(message) {
    return regeneratorRuntime.wrap(function test1$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return cmds.echo(message);

          case 2:
            return _context3.abrupt("return", _context3.sent);

          case 3:
          case "end":
            return _context3.stop();
        }
      }
    }, _marked3, this);
  }

  var p = promisify(test1);
  expect(p).toEqual(promisify(p));
});
test("promisify should wrap up an effects-as-data function",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee() {
  var _marked4, test1, result;

  return regeneratorRuntime.wrap(function _callee$(_context5) {
    while (1) {
      switch (_context5.prev = _context5.next) {
        case 0:
          test1 = function _ref2(message) {
            return regeneratorRuntime.wrap(function test1$(_context4) {
              while (1) {
                switch (_context4.prev = _context4.next) {
                  case 0:
                    _context4.next = 2;
                    return cmds.echo(message);

                  case 2:
                    return _context4.abrupt("return", _context4.sent);

                  case 3:
                  case "end":
                    return _context4.stop();
                }
              }
            }, _marked4, this);
          };

          _marked4 =
          /*#__PURE__*/
          regeneratorRuntime.mark(test1);
          _context5.next = 4;
          return promisify(test1)("foo");

        case 4:
          result = _context5.sent;
          expect(result).toEqual("foo");

        case 6:
        case "end":
          return _context5.stop();
      }
    }
  }, _callee, this);
})));
test("promisify should handle errors",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee2() {
  var _marked5, test1;

  return regeneratorRuntime.wrap(function _callee2$(_context7) {
    while (1) {
      switch (_context7.prev = _context7.next) {
        case 0:
          test1 = function _ref4(message) {
            return regeneratorRuntime.wrap(function test1$(_context6) {
              while (1) {
                switch (_context6.prev = _context6.next) {
                  case 0:
                    throw new Error("oops");

                  case 1:
                  case "end":
                    return _context6.stop();
                }
              }
            }, _marked5, this);
          };

          _marked5 =
          /*#__PURE__*/
          regeneratorRuntime.mark(test1);
          _context7.prev = 2;
          _context7.next = 5;
          return promisify(test1)("foo");

        case 5:
          _context7.next = 11;
          break;

        case 7:
          _context7.prev = 7;
          _context7.t0 = _context7["catch"](2);
          expect(_context7.t0.message).toEqual("oops");
          return _context7.abrupt("return");

        case 11:
          fail("promisify did not reject");

        case 12:
        case "end":
          return _context7.stop();
      }
    }
  }, _callee2, this, [[2, 7]]);
})));
test("call should call a function",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee3() {
  var _marked6, test1, result;

  return regeneratorRuntime.wrap(function _callee3$(_context9) {
    while (1) {
      switch (_context9.prev = _context9.next) {
        case 0:
          test1 = function _ref6(message) {
            return regeneratorRuntime.wrap(function test1$(_context8) {
              while (1) {
                switch (_context8.prev = _context8.next) {
                  case 0:
                    _context8.next = 2;
                    return cmds.echo(message);

                  case 2:
                    return _context8.abrupt("return", _context8.sent);

                  case 3:
                  case "end":
                    return _context8.stop();
                }
              }
            }, _marked6, this);
          };

          _marked6 =
          /*#__PURE__*/
          regeneratorRuntime.mark(test1);
          _context9.next = 4;
          return call(test1, "foo");

        case 4:
          result = _context9.sent;
          expect(result).toEqual("foo");

        case 6:
        case "end":
          return _context9.stop();
      }
    }
  }, _callee3, this);
})));
test("doCmd should process a command",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee4() {
  var result;
  return regeneratorRuntime.wrap(function _callee4$(_context10) {
    while (1) {
      switch (_context10.prev = _context10.next) {
        case 0:
          _context10.next = 2;
          return doCmd(cmds.echo("foo"));

        case 2:
          result = _context10.sent;
          expect(result).toEqual("foo");

        case 4:
        case "end":
          return _context10.stop();
      }
    }
  }, _callee4, this);
})));
test("cmds.call should call effects-as-data function",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee5() {
  var _marked7, _marked8, test1, test2, result;

  return regeneratorRuntime.wrap(function _callee5$(_context13) {
    while (1) {
      switch (_context13.prev = _context13.next) {
        case 0:
          test2 = function _ref10(message) {
            return regeneratorRuntime.wrap(function test2$(_context12) {
              while (1) {
                switch (_context12.prev = _context12.next) {
                  case 0:
                    _context12.next = 2;
                    return cmds.echo(message);

                  case 2:
                    return _context12.abrupt("return", _context12.sent);

                  case 3:
                  case "end":
                    return _context12.stop();
                }
              }
            }, _marked8, this);
          };

          test1 = function _ref9(message) {
            return regeneratorRuntime.wrap(function test1$(_context11) {
              while (1) {
                switch (_context11.prev = _context11.next) {
                  case 0:
                    _context11.next = 2;
                    return cmds.call(test2, message);

                  case 2:
                    return _context11.abrupt("return", _context11.sent);

                  case 3:
                  case "end":
                    return _context11.stop();
                }
              }
            }, _marked7, this);
          };

          _marked7 =
          /*#__PURE__*/
          regeneratorRuntime.mark(test1), _marked8 =
          /*#__PURE__*/
          regeneratorRuntime.mark(test2);
          _context13.next = 5;
          return promisify(test1)("foo");

        case 5:
          result = _context13.sent;
          expect(result).toEqual("foo");

        case 7:
        case "end":
          return _context13.stop();
      }
    }
  }, _callee5, this);
})));
test("[error handling] cmds.call should call effects-as-data function",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee6() {
  var _marked9, _marked10, test1, test2;

  return regeneratorRuntime.wrap(function _callee6$(_context16) {
    while (1) {
      switch (_context16.prev = _context16.next) {
        case 0:
          test2 = function _ref13(message) {
            return regeneratorRuntime.wrap(function test2$(_context15) {
              while (1) {
                switch (_context15.prev = _context15.next) {
                  case 0:
                    throw new Error("oops");

                  case 1:
                  case "end":
                    return _context15.stop();
                }
              }
            }, _marked10, this);
          };

          test1 = function _ref12(message) {
            return regeneratorRuntime.wrap(function test1$(_context14) {
              while (1) {
                switch (_context14.prev = _context14.next) {
                  case 0:
                    _context14.next = 2;
                    return cmds.call(test2, message);

                  case 2:
                    return _context14.abrupt("return", _context14.sent);

                  case 3:
                  case "end":
                    return _context14.stop();
                }
              }
            }, _marked9, this);
          };

          _marked9 =
          /*#__PURE__*/
          regeneratorRuntime.mark(test1), _marked10 =
          /*#__PURE__*/
          regeneratorRuntime.mark(test2);
          _context16.prev = 3;
          _context16.next = 6;
          return promisify(test1)("foo");

        case 6:
          _context16.next = 12;
          break;

        case 8:
          _context16.prev = 8;
          _context16.t0 = _context16["catch"](3);
          expect(_context16.t0.message).toEqual("oops");
          return _context16.abrupt("return");

        case 12:
          fail("promisify did not reject");

        case 13:
        case "end":
          return _context16.stop();
      }
    }
  }, _callee6, this, [[3, 8]]);
})));
test("cmds.call should call promisified function",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee8() {
  var _marked11, test1, test2, result;

  return regeneratorRuntime.wrap(function _callee8$(_context19) {
    while (1) {
      switch (_context19.prev = _context19.next) {
        case 0:
          test1 = function _ref15(message) {
            return regeneratorRuntime.wrap(function test1$(_context17) {
              while (1) {
                switch (_context17.prev = _context17.next) {
                  case 0:
                    _context17.next = 2;
                    return cmds.call(test2, message);

                  case 2:
                    return _context17.abrupt("return", _context17.sent);

                  case 3:
                  case "end":
                    return _context17.stop();
                }
              }
            }, _marked11, this);
          };

          _marked11 =
          /*#__PURE__*/
          regeneratorRuntime.mark(test1);
          test2 = promisify(
          /*#__PURE__*/
          regeneratorRuntime.mark(function _callee7(message) {
            return regeneratorRuntime.wrap(function _callee7$(_context18) {
              while (1) {
                switch (_context18.prev = _context18.next) {
                  case 0:
                    _context18.next = 2;
                    return cmds.echo(message);

                  case 2:
                    return _context18.abrupt("return", _context18.sent);

                  case 3:
                  case "end":
                    return _context18.stop();
                }
              }
            }, _callee7, this);
          }));
          _context19.next = 5;
          return promisify(test1)("foo");

        case 5:
          result = _context19.sent;
          expect(result).toEqual("foo");

        case 7:
        case "end":
          return _context19.stop();
      }
    }
  }, _callee8, this);
})));
test("[error handling] cmds.call should call promisified function",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee10() {
  var _marked12, test1, test2;

  return regeneratorRuntime.wrap(function _callee10$(_context22) {
    while (1) {
      switch (_context22.prev = _context22.next) {
        case 0:
          test1 = function _ref17(message) {
            return regeneratorRuntime.wrap(function test1$(_context20) {
              while (1) {
                switch (_context20.prev = _context20.next) {
                  case 0:
                    _context20.next = 2;
                    return cmds.call(test2, message);

                  case 2:
                    return _context20.abrupt("return", _context20.sent);

                  case 3:
                  case "end":
                    return _context20.stop();
                }
              }
            }, _marked12, this);
          };

          _marked12 =
          /*#__PURE__*/
          regeneratorRuntime.mark(test1);
          test2 = promisify(
          /*#__PURE__*/
          regeneratorRuntime.mark(function _callee9(message) {
            return regeneratorRuntime.wrap(function _callee9$(_context21) {
              while (1) {
                switch (_context21.prev = _context21.next) {
                  case 0:
                    throw new Error("oops");

                  case 1:
                  case "end":
                    return _context21.stop();
                }
              }
            }, _callee9, this);
          }));
          _context22.prev = 3;
          _context22.next = 6;
          return promisify(test1)("foo");

        case 6:
          _context22.next = 12;
          break;

        case 8:
          _context22.prev = 8;
          _context22.t0 = _context22["catch"](3);
          expect(_context22.t0.message).toEqual("oops");
          return _context22.abrupt("return");

        case 12:
          fail("promisify did not reject");

        case 13:
        case "end":
          return _context22.stop();
      }
    }
  }, _callee10, this, [[3, 8]]);
})));
test("cmds.call.fn should call promisified function",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee12() {
  var _marked13, test1, test2, result;

  return regeneratorRuntime.wrap(function _callee12$(_context25) {
    while (1) {
      switch (_context25.prev = _context25.next) {
        case 0:
          test1 = function _ref19(message) {
            return regeneratorRuntime.wrap(function test1$(_context23) {
              while (1) {
                switch (_context23.prev = _context23.next) {
                  case 0:
                    _context23.next = 2;
                    return cmds.call.fn(test2, message);

                  case 2:
                    return _context23.abrupt("return", _context23.sent);

                  case 3:
                  case "end":
                    return _context23.stop();
                }
              }
            }, _marked13, this);
          };

          _marked13 =
          /*#__PURE__*/
          regeneratorRuntime.mark(test1);
          test2 = promisify(
          /*#__PURE__*/
          regeneratorRuntime.mark(function _callee11(message) {
            return regeneratorRuntime.wrap(function _callee11$(_context24) {
              while (1) {
                switch (_context24.prev = _context24.next) {
                  case 0:
                    _context24.next = 2;
                    return cmds.echo(message);

                  case 2:
                    return _context24.abrupt("return", _context24.sent);

                  case 3:
                  case "end":
                    return _context24.stop();
                }
              }
            }, _callee11, this);
          }));
          _context25.next = 5;
          return promisify(test1)("foo");

        case 5:
          result = _context25.sent;
          expect(result).toEqual("foo");

        case 7:
        case "end":
          return _context25.stop();
      }
    }
  }, _callee12, this);
})));
test("[error handling] cmds.call.fn should call promisified function",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee14() {
  var _marked14, test1, test2;

  return regeneratorRuntime.wrap(function _callee14$(_context28) {
    while (1) {
      switch (_context28.prev = _context28.next) {
        case 0:
          test1 = function _ref21(message) {
            return regeneratorRuntime.wrap(function test1$(_context26) {
              while (1) {
                switch (_context26.prev = _context26.next) {
                  case 0:
                    _context26.next = 2;
                    return cmds.call.fn(test2, message);

                  case 2:
                    return _context26.abrupt("return", _context26.sent);

                  case 3:
                  case "end":
                    return _context26.stop();
                }
              }
            }, _marked14, this);
          };

          _marked14 =
          /*#__PURE__*/
          regeneratorRuntime.mark(test1);
          test2 = promisify(
          /*#__PURE__*/
          regeneratorRuntime.mark(function _callee13(message) {
            return regeneratorRuntime.wrap(function _callee13$(_context27) {
              while (1) {
                switch (_context27.prev = _context27.next) {
                  case 0:
                    throw new Error("oops");

                  case 1:
                  case "end":
                    return _context27.stop();
                }
              }
            }, _callee13, this);
          }));
          _context28.prev = 3;
          _context28.next = 6;
          return promisify(test1)("foo");

        case 6:
          _context28.next = 12;
          break;

        case 8:
          _context28.prev = 8;
          _context28.t0 = _context28["catch"](3);
          expect(_context28.t0.message).toEqual("oops");
          return _context28.abrupt("return");

        case 12:
          fail("promisify did not reject");

        case 13:
        case "end":
          return _context28.stop();
      }
    }
  }, _callee14, this, [[3, 8]]);
})));
test("cmds.call.fn should call promise returning function",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee15() {
  var _marked15, test1, test2, result;

  return regeneratorRuntime.wrap(function _callee15$(_context30) {
    while (1) {
      switch (_context30.prev = _context30.next) {
        case 0:
          test2 = function _ref24(message) {
            return Promise.resolve(message);
          };

          test1 = function _ref23(message) {
            return regeneratorRuntime.wrap(function test1$(_context29) {
              while (1) {
                switch (_context29.prev = _context29.next) {
                  case 0:
                    _context29.next = 2;
                    return cmds.call.fn(test2, message);

                  case 2:
                    return _context29.abrupt("return", _context29.sent);

                  case 3:
                  case "end":
                    return _context29.stop();
                }
              }
            }, _marked15, this);
          };

          _marked15 =
          /*#__PURE__*/
          regeneratorRuntime.mark(test1);
          _context30.next = 5;
          return promisify(test1)("foo");

        case 5:
          result = _context30.sent;
          expect(result).toEqual("foo");

        case 7:
        case "end":
          return _context30.stop();
      }
    }
  }, _callee15, this);
})));
test("[error handling] cmds.call.fn should call promise returning function",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee16() {
  var _marked16, test1, test2;

  return regeneratorRuntime.wrap(function _callee16$(_context32) {
    while (1) {
      switch (_context32.prev = _context32.next) {
        case 0:
          test2 = function _ref27(message) {
            throw new Error("oops");
          };

          test1 = function _ref26(message) {
            return regeneratorRuntime.wrap(function test1$(_context31) {
              while (1) {
                switch (_context31.prev = _context31.next) {
                  case 0:
                    _context31.next = 2;
                    return cmds.call.fn(test2, message);

                  case 2:
                    return _context31.abrupt("return", _context31.sent);

                  case 3:
                  case "end":
                    return _context31.stop();
                }
              }
            }, _marked16, this);
          };

          _marked16 =
          /*#__PURE__*/
          regeneratorRuntime.mark(test1);
          _context32.prev = 3;
          _context32.next = 6;
          return promisify(test1)("foo");

        case 6:
          _context32.next = 12;
          break;

        case 8:
          _context32.prev = 8;
          _context32.t0 = _context32["catch"](3);
          expect(_context32.t0.message).toEqual("oops");
          return _context32.abrupt("return");

        case 12:
          fail("promisify did not reject");

        case 13:
        case "end":
          return _context32.stop();
      }
    }
  }, _callee16, this, [[3, 8]]);
})));
test("cmds.call.fnBound should call promise returning function",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee17() {
  var _marked17, test1, obj, result;

  return regeneratorRuntime.wrap(function _callee17$(_context34) {
    while (1) {
      switch (_context34.prev = _context34.next) {
        case 0:
          test1 = function _ref29(message) {
            return regeneratorRuntime.wrap(function test1$(_context33) {
              while (1) {
                switch (_context33.prev = _context33.next) {
                  case 0:
                    _context33.next = 2;
                    return cmds.call.fnBound(obj, obj.test2, message);

                  case 2:
                    return _context33.abrupt("return", _context33.sent);

                  case 3:
                  case "end":
                    return _context33.stop();
                }
              }
            }, _marked17, this);
          };

          _marked17 =
          /*#__PURE__*/
          regeneratorRuntime.mark(test1);
          obj = {
            value: "bar",
            test2: function test2(message) {
              return Promise.resolve("".concat(message).concat(this.value));
            }
          };
          _context34.next = 5;
          return promisify(test1)("foo");

        case 5:
          result = _context34.sent;
          expect(result).toEqual("foobar");

        case 7:
        case "end":
          return _context34.stop();
      }
    }
  }, _callee17, this);
})));
test("[error handling] cmds.call.fnBound should call promise returning function",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee18() {
  var _marked18, test1, obj;

  return regeneratorRuntime.wrap(function _callee18$(_context36) {
    while (1) {
      switch (_context36.prev = _context36.next) {
        case 0:
          test1 = function _ref31(message) {
            return regeneratorRuntime.wrap(function test1$(_context35) {
              while (1) {
                switch (_context35.prev = _context35.next) {
                  case 0:
                    _context35.next = 2;
                    return cmds.call.fnBound(obj, obj.test2, message);

                  case 2:
                    return _context35.abrupt("return", _context35.sent);

                  case 3:
                  case "end":
                    return _context35.stop();
                }
              }
            }, _marked18, this);
          };

          _marked18 =
          /*#__PURE__*/
          regeneratorRuntime.mark(test1);
          obj = {
            value: "bar",
            test2: function test2(message) {
              throw new Error("oops");
            }
          };
          _context36.prev = 3;
          _context36.next = 6;
          return promisify(test1)("foo");

        case 6:
          _context36.next = 12;
          break;

        case 8:
          _context36.prev = 8;
          _context36.t0 = _context36["catch"](3);
          expect(_context36.t0.message).toEqual("oops");
          return _context36.abrupt("return");

        case 12:
          fail("promisify did not reject");

        case 13:
        case "end":
          return _context36.stop();
      }
    }
  }, _callee18, this, [[3, 8]]);
})));
test("cmds.call.callback should call callback function",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee19() {
  var _marked19, test1, test2, result;

  return regeneratorRuntime.wrap(function _callee19$(_context38) {
    while (1) {
      switch (_context38.prev = _context38.next) {
        case 0:
          test2 = function _ref34(message, done) {
            done(null, message);
          };

          test1 = function _ref33(message) {
            return regeneratorRuntime.wrap(function test1$(_context37) {
              while (1) {
                switch (_context37.prev = _context37.next) {
                  case 0:
                    _context37.next = 2;
                    return cmds.call.callback(test2, message);

                  case 2:
                    return _context37.abrupt("return", _context37.sent);

                  case 3:
                  case "end":
                    return _context37.stop();
                }
              }
            }, _marked19, this);
          };

          _marked19 =
          /*#__PURE__*/
          regeneratorRuntime.mark(test1);
          _context38.next = 5;
          return promisify(test1)("foo");

        case 5:
          result = _context38.sent;
          expect(result).toEqual("foo");

        case 7:
        case "end":
          return _context38.stop();
      }
    }
  }, _callee19, this);
})));
test("[error handling] cmds.call.callback should call callback function",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee20() {
  var _marked20, test1, test2;

  return regeneratorRuntime.wrap(function _callee20$(_context40) {
    while (1) {
      switch (_context40.prev = _context40.next) {
        case 0:
          test2 = function _ref37(message, done) {
            done(new Error("oops"), message);
          };

          test1 = function _ref36(message) {
            return regeneratorRuntime.wrap(function test1$(_context39) {
              while (1) {
                switch (_context39.prev = _context39.next) {
                  case 0:
                    _context39.next = 2;
                    return cmds.call.callback(test2, message);

                  case 2:
                    return _context39.abrupt("return", _context39.sent);

                  case 3:
                  case "end":
                    return _context39.stop();
                }
              }
            }, _marked20, this);
          };

          _marked20 =
          /*#__PURE__*/
          regeneratorRuntime.mark(test1);
          _context40.prev = 3;
          _context40.next = 6;
          return promisify(test1)("foo");

        case 6:
          _context40.next = 12;
          break;

        case 8:
          _context40.prev = 8;
          _context40.t0 = _context40["catch"](3);
          expect(_context40.t0.message).toEqual("oops");
          return _context40.abrupt("return");

        case 12:
          fail("promisify did not reject");

        case 13:
        case "end":
          return _context40.stop();
      }
    }
  }, _callee20, this, [[3, 8]]);
})));
test("[error handling 2] cmds.call.callback should call callback function",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee21() {
  var _marked21, test1, test2;

  return regeneratorRuntime.wrap(function _callee21$(_context42) {
    while (1) {
      switch (_context42.prev = _context42.next) {
        case 0:
          test2 = function _ref40(message, done) {
            throw new Error("oops");
          };

          test1 = function _ref39(message) {
            return regeneratorRuntime.wrap(function test1$(_context41) {
              while (1) {
                switch (_context41.prev = _context41.next) {
                  case 0:
                    _context41.next = 2;
                    return cmds.call.callback(test2, message);

                  case 2:
                    return _context41.abrupt("return", _context41.sent);

                  case 3:
                  case "end":
                    return _context41.stop();
                }
              }
            }, _marked21, this);
          };

          _marked21 =
          /*#__PURE__*/
          regeneratorRuntime.mark(test1);
          _context42.prev = 3;
          _context42.next = 6;
          return promisify(test1)("foo");

        case 6:
          _context42.next = 12;
          break;

        case 8:
          _context42.prev = 8;
          _context42.t0 = _context42["catch"](3);
          expect(_context42.t0.message).toEqual("oops");
          return _context42.abrupt("return");

        case 12:
          fail("promisify did not reject");

        case 13:
        case "end":
          return _context42.stop();
      }
    }
  }, _callee21, this, [[3, 8]]);
})));
test("cmds.call.callbackBound should call callback function",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee22() {
  var _marked22, test1, obj, result;

  return regeneratorRuntime.wrap(function _callee22$(_context44) {
    while (1) {
      switch (_context44.prev = _context44.next) {
        case 0:
          test1 = function _ref42(message) {
            return regeneratorRuntime.wrap(function test1$(_context43) {
              while (1) {
                switch (_context43.prev = _context43.next) {
                  case 0:
                    _context43.next = 2;
                    return cmds.call.callbackBound(obj, obj.test2, message);

                  case 2:
                    return _context43.abrupt("return", _context43.sent);

                  case 3:
                  case "end":
                    return _context43.stop();
                }
              }
            }, _marked22, this);
          };

          _marked22 =
          /*#__PURE__*/
          regeneratorRuntime.mark(test1);
          obj = {
            value: "bar",
            test2: function test2(message, done) {
              done(null, "".concat(message).concat(this.value));
            }
          };
          _context44.next = 5;
          return promisify(test1)("foo");

        case 5:
          result = _context44.sent;
          expect(result).toEqual("foobar");

        case 7:
        case "end":
          return _context44.stop();
      }
    }
  }, _callee22, this);
})));
test("[error handling] cmds.call.callbackBound should call callback function",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee23() {
  var _marked23, test1, obj;

  return regeneratorRuntime.wrap(function _callee23$(_context46) {
    while (1) {
      switch (_context46.prev = _context46.next) {
        case 0:
          test1 = function _ref44(message) {
            return regeneratorRuntime.wrap(function test1$(_context45) {
              while (1) {
                switch (_context45.prev = _context45.next) {
                  case 0:
                    _context45.next = 2;
                    return cmds.call.callbackBound(obj, obj.test2, message);

                  case 2:
                    return _context45.abrupt("return", _context45.sent);

                  case 3:
                  case "end":
                    return _context45.stop();
                }
              }
            }, _marked23, this);
          };

          _marked23 =
          /*#__PURE__*/
          regeneratorRuntime.mark(test1);
          obj = {
            value: "bar",
            test2: function test2(message, done) {
              done(new Error("oops"), "".concat(message).concat(this.value));
            }
          };
          _context46.prev = 3;
          _context46.next = 6;
          return promisify(test1)("foo");

        case 6:
          _context46.next = 12;
          break;

        case 8:
          _context46.prev = 8;
          _context46.t0 = _context46["catch"](3);
          expect(_context46.t0.message).toEqual("oops");
          return _context46.abrupt("return");

        case 12:
          fail("promisify did not reject");

        case 13:
        case "end":
          return _context46.stop();
      }
    }
  }, _callee23, this, [[3, 8]]);
})));
test("[error handling] cmds.call.callbackBound should call callback function",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee24() {
  var _marked24, test1, obj;

  return regeneratorRuntime.wrap(function _callee24$(_context48) {
    while (1) {
      switch (_context48.prev = _context48.next) {
        case 0:
          test1 = function _ref46(message) {
            return regeneratorRuntime.wrap(function test1$(_context47) {
              while (1) {
                switch (_context47.prev = _context47.next) {
                  case 0:
                    _context47.next = 2;
                    return cmds.call.callbackBound(obj, obj.test2, message);

                  case 2:
                    return _context47.abrupt("return", _context47.sent);

                  case 3:
                  case "end":
                    return _context47.stop();
                }
              }
            }, _marked24, this);
          };

          _marked24 =
          /*#__PURE__*/
          regeneratorRuntime.mark(test1);
          obj = {
            value: "bar",
            test2: function test2(message, done) {
              throw new Error("oops");
            }
          };
          _context48.prev = 3;
          _context48.next = 6;
          return promisify(test1)("foo");

        case 6:
          _context48.next = 12;
          break;

        case 8:
          _context48.prev = 8;
          _context48.t0 = _context48["catch"](3);
          expect(_context48.t0.message).toEqual("oops");
          return _context48.abrupt("return");

        case 12:
          fail("promisify did not reject");

        case 13:
        case "end":
          return _context48.stop();
      }
    }
  }, _callee24, this, [[3, 8]]);
})));
test("promisify(fn).callWithContext({...}) should call function with context patch",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee25() {
  var _marked25, testEffect, test1, result1, result2;

  return regeneratorRuntime.wrap(function _callee25$(_context50) {
    while (1) {
      switch (_context50.prev = _context50.next) {
        case 0:
          test1 = function _ref50(message) {
            var result;
            return regeneratorRuntime.wrap(function test1$(_context49) {
              while (1) {
                switch (_context49.prev = _context49.next) {
                  case 0:
                    _context49.next = 2;
                    return {
                      type: "testEffect"
                    };

                  case 2:
                    result = _context49.sent;
                    return _context49.abrupt("return", "".concat(result).concat(message));

                  case 4:
                  case "end":
                    return _context49.stop();
                }
              }
            }, _marked25, this);
          };

          testEffect = function _ref49(cmd, _ref48) {
            var context = _ref48.context;
            return context.configProperty;
          };

          _marked25 =
          /*#__PURE__*/
          regeneratorRuntime.mark(test1);
          setContext({
            configProperty: "foo"
          }); // Interpreter

          addInterpreters({
            testEffect: testEffect
          });
          _context50.next = 7;
          return promisify(test1)("bar");

        case 7:
          result1 = _context50.sent;
          expect(result1).toEqual("foobar");
          _context50.next = 11;
          return promisify(test1).callWithContext({
            configProperty: "bar"
          }, "bar");

        case 11:
          result2 = _context50.sent;
          expect(result2).toEqual("barbar");

        case 13:
        case "end":
          return _context50.stop();
      }
    }
  }, _callee25, this);
})));
test("promisify(fn).callWithContext({...}) should call function with context patch and call validator",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee26() {
  var _marked26, testEffect, test1;

  return regeneratorRuntime.wrap(function _callee26$(_context52) {
    while (1) {
      switch (_context52.prev = _context52.next) {
        case 0:
          test1 = function _ref54(message) {
            var result;
            return regeneratorRuntime.wrap(function test1$(_context51) {
              while (1) {
                switch (_context51.prev = _context51.next) {
                  case 0:
                    _context51.next = 2;
                    return {
                      type: "testEffect"
                    };

                  case 2:
                    result = _context51.sent;
                    return _context51.abrupt("return", "".concat(result).concat(message));

                  case 4:
                  case "end":
                    return _context51.stop();
                }
              }
            }, _marked26, this);
          };

          testEffect = function _ref53(cmd, _ref52) {
            var context = _ref52.context;
            return context.configProperty;
          };

          _marked26 =
          /*#__PURE__*/
          regeneratorRuntime.mark(test1);
          setContext({
            configProperty: "foo"
          }); // Interpreter

          addInterpreters({
            testEffect: testEffect
          });

          test1.validator = function () {
            throw new Error("not valid");
          };

          _context52.prev = 6;
          _context52.next = 9;
          return promisify(test1).callWithContext({
            configProperty: "bar"
          }, "bar");

        case 9:
          _context52.next = 15;
          break;

        case 11:
          _context52.prev = 11;
          _context52.t0 = _context52["catch"](6);
          expect(_context52.t0.message).toEqual("not valid");
          return _context52.abrupt("return");

        case 15:
          fail("did not throw");

        case 16:
        case "end":
          return _context52.stop();
      }
    }
  }, _callee26, this, [[6, 11]]);
})));
test("addInterpreters(), getInterpreters(), setInterpreters()", function () {
  reset();

  function testEffect1() {
    return "test1";
  }

  function testEffect2() {
    return "test2";
  }

  expect(getInterpreters()).toEqual({});
  addInterpreters({
    testEffect1: testEffect1
  });
  expect(getInterpreters()).toEqual({
    testEffect1: testEffect1
  });
  addInterpreters({
    testEffect2: testEffect2
  });
  expect(getInterpreters()).toEqual({
    testEffect1: testEffect1,
    testEffect2: testEffect2
  });
  setInterpreters({});
  expect(getInterpreters()).toEqual({});
});
test("addToContext(), getContext(), setContext()", function () {
  reset();
  expect(getContext()).toEqual({});
  addToContext({
    test1: "foo"
  });
  expect(getContext()).toEqual({
    test1: "foo"
  });
  addToContext({
    test2: "bar"
  });
  expect(getContext()).toEqual({
    test1: "foo",
    test2: "bar"
  });
  setContext({});
  expect(getContext()).toEqual({});
});
test("onError() should register error handler on context", function () {
  var handler = function handler() {};

  onError(handler);
  var context = getContext();
  expect(context.onError).toEqual(handler);
});
test("onError() should throw if handler is not a function", function () {
  expect(onError).toThrow("onError requires a function");
});
test("effect() should return a call cmd", function () {
  var fn = function fn() {};

  var actual = effect(fn)("foo", "bar");
  var expected = cmds.call.fn(fn, "foo", "bar");
  expect(actual).toEqual(expected);
});
test("effect() should call function",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee28() {
  var eadFn, result;
  return regeneratorRuntime.wrap(function _callee28$(_context54) {
    while (1) {
      switch (_context54.prev = _context54.next) {
        case 0:
          addInterpreters(interpreters);
          eadFn = effect(function (m) {
            return m;
          });
          _context54.next = 4;
          return promisify(
          /*#__PURE__*/
          regeneratorRuntime.mark(function _callee27() {
            return regeneratorRuntime.wrap(function _callee27$(_context53) {
              while (1) {
                switch (_context53.prev = _context53.next) {
                  case 0:
                    _context53.next = 2;
                    return eadFn("foo");

                  case 2:
                    return _context53.abrupt("return", _context53.sent);

                  case 3:
                  case "end":
                    return _context53.stop();
                }
              }
            }, _callee27, this);
          }))();

        case 4:
          result = _context54.sent;
          expect(result).toEqual("foo");

        case 6:
        case "end":
          return _context54.stop();
      }
    }
  }, _callee28, this);
})));
test("effect() should call validator, if present", function () {
  addInterpreters(interpreters);

  var validator = function validator() {
    throw new Error("required");
  };

  var eadFn = effect(function (m) {
    return m;
  }, validator);
  expect(eadFn).toThrow("required");
});
test("effect() should throw if validator is not a function", function () {
  addInterpreters(interpreters);
  var validator = 0; // validator is not a function

  expect(function () {
    return effect(function (m) {
      return m;
    }, validator);
  }).toThrow("validator must be a function");
});
//# sourceMappingURL=index.spec.js.map