"use strict";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _require = require("../test"),
    testFn = _require.testFn,
    args = _require.args;

var _require2 = require("../index"),
    promisify = _require2.promisify;

var call = require("../index").cmds.call;

test("validator get called during unit test", function () {
  var _marked =
  /*#__PURE__*/
  regeneratorRuntime.mark(subject);

  function subject() {
    return regeneratorRuntime.wrap(function subject$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt("return", "foo");

          case 1:
          case "end":
            return _context.stop();
        }
      }
    }, _marked, this);
  }

  subject.validator = function (user) {
    if (!user) throw new Error("User required.");
  };

  try {
    testFn(subject, function () {
      return args().returns("foo");
    })();
  } catch (e) {
    expect(e.message).toEqual("User required.");
    return;
  }

  fail("testFn did not throw");
});
test("validator get called inside call function inside unit test", function () {
  var _marked2 =
  /*#__PURE__*/
  regeneratorRuntime.mark(test),
      _marked3 =
  /*#__PURE__*/
  regeneratorRuntime.mark(subject);

  var user = {};

  function test() {
    return regeneratorRuntime.wrap(function test$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return call(subject, user);

          case 2:
            return _context2.abrupt("return", _context2.sent);

          case 3:
          case "end":
            return _context2.stop();
        }
      }
    }, _marked2, this);
  }

  function subject() {
    return regeneratorRuntime.wrap(function subject$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            return _context3.abrupt("return", "foo");

          case 1:
          case "end":
            return _context3.stop();
        }
      }
    }, _marked3, this);
  }

  subject.validator = function (user) {
    if (!user) throw new Error("User required.");
  };

  try {
    testFn(test, function () {
      // prettier-ignore
      return args().cmd(call(subject)).returns("foo");
    })();
  } catch (e) {
    expect(e.message).toEqual("User required.");
    return;
  }

  fail("testFn did not throw");
});
test("validator get called inside call function from inside ead function", function () {
  var _marked4 =
  /*#__PURE__*/
  regeneratorRuntime.mark(test),
      _marked5 =
  /*#__PURE__*/
  regeneratorRuntime.mark(subject);

  var user = {};

  function test() {
    return regeneratorRuntime.wrap(function test$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return call(subject);

          case 2:
            return _context4.abrupt("return", _context4.sent);

          case 3:
          case "end":
            return _context4.stop();
        }
      }
    }, _marked4, this);
  }

  function subject() {
    return regeneratorRuntime.wrap(function subject$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            return _context5.abrupt("return", "foo");

          case 1:
          case "end":
            return _context5.stop();
        }
      }
    }, _marked5, this);
  }

  subject.validator = function (user) {
    if (!user) throw new Error("User required.");
  };

  try {
    testFn(test, function () {
      // prettier-ignore
      return args().cmd(call(subject, user)).returns("foo");
    })();
  } catch (e) {
    expect(e.message.match(/expect/gi)).toBeTruthy();
    return;
  }

  fail("testFn did not throw");
});
test("validator get called during runtime",
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee() {
  var _marked6, subject;

  return regeneratorRuntime.wrap(function _callee$(_context7) {
    while (1) {
      switch (_context7.prev = _context7.next) {
        case 0:
          subject = function _ref2() {
            return regeneratorRuntime.wrap(function subject$(_context6) {
              while (1) {
                switch (_context6.prev = _context6.next) {
                  case 0:
                    return _context6.abrupt("return", "foo");

                  case 1:
                  case "end":
                    return _context6.stop();
                }
              }
            }, _marked6, this);
          };

          _marked6 =
          /*#__PURE__*/
          regeneratorRuntime.mark(subject);

          subject.validator = function (user) {
            if (!user) throw new Error("User required.");
          };

          _context7.prev = 3;
          _context7.next = 6;
          return promisify(subject)();

        case 6:
          _context7.next = 12;
          break;

        case 8:
          _context7.prev = 8;
          _context7.t0 = _context7["catch"](3);
          expect(_context7.t0.message).toEqual("User required.");
          return _context7.abrupt("return");

        case 12:
          fail("validator did not throw");

        case 13:
        case "end":
          return _context7.stop();
      }
    }
  }, _callee, this, [[3, 8]]);
})));
//# sourceMappingURL=validators.spec.js.map